// Soubor Metadata/Program.java
// Testuje, zda je u metody pouita anotace @Test
import java.lang.reflect.*;

public class Program
{
  public static void main(String[] jmno) throws Exception
  {
    int celkem = 0, vjimkou = 0;
    for(Method m: Class.forName(jmno[0]).getMethods())
    {
      if(m.isAnnotationPresent(Test.class))
       try {
         celkem++;
         m.invoke(null); // m.invoke(null, null);
       } catch (Throwable vj)
       {
         System.out.printf("Test metody %s skonil vjimkou:"
            +" %s %n", m, vj.getCause());
         vjimkou++;
       }
    }
    System.out.printf("Celkem testovno: %d, vjimkou "
       + "skonilo: %d%n metod", celkem, vjimkou);
  }
}
