// Soubor Smery.java
// Ukzka deklarace vtovho typu  
// a jeho pouit v pkazu switch

// Vtov typ s dodatenou metodou
enum Smr {
  SEVER("S"), JIH("J"), VCHOD("V"), ZPAD("Z");    
  private Smr(String zkr){zkratka = zkr;}
  public String getZkratka() {return zkratka;}
  private String zkratka;
}

// Triviln pklad pouit
public class Smery
{
  
  // Nkolik metod pro rzn smry
  public static void jdiTam()
  {
    System.out.println("Jdu tam");
  }
  public static void jdiJinam()
  {
    System.out.println("Jdu jinam");
  }
  public static void ute()
  {
    System.out.println("Utkm");
  }
  public static void nechoNikam()
  {
    System.out.println("Nejdu nikam");
  }

  // Pouit vtovho typu
  public static void jdi(Smr x)
  {
    System.out.println(x.name());
    System.out.println(x.toString());
    System.out.println(x.getZkratka());
    switch(x)
    {
      case SEVER: 
        jdiTam(); break;
      case JIH:   
        jdiJinam(); break;
      case VCHOD:   
        ute(); break;
      case ZPAD:   
        nechoNikam(); break;
    }
  }  

  public static void main(String[] arg)
  {
   jdi(Smr.VCHOD); 
  }
}
