// Soubor Vararg.java
// Pklad metody s promnnm potem parametr

class Mat
{
  // Najde nejmen z neznmho potu parametr
  public static int minimum(int ... sla)
  {
    int pom = Integer.MAX_VALUE;
    for(int m: sla) if(m < pom) pom = m;
    return pom;
  }
}

public class Vararg
{
  public static void main(String [] s)
  {
    int x = 67, y = -54, z = 76;
    System.out.println(Mat.minimum(x, y, z)); // Nejmen ze 3 sel: -54
    System.out.println(Mat.minimum());        // Vrt 2147483647
    int[] hodnoty = {9, 8, 7, 6, 5, 4, 10};   // Pouit pro pole
    System.out.println(Mat.minimum(hodnoty)); // Vrt 4
  }
}