import java.util.*;

class Osoba 
{
  protected String jmno;
  public Osoba(String jm){jmno = jm;}
  public String toString() {return "Osoba "+jmno;}
}

class Student extends Osoba 
{
   private int ronk;
   public Student(String jm, int ro)
   {
     super(jm);
     ronk = ro;
   }
   public String toString(){
    return "Student " + jmno + ", " + ronk + ". ronk";
   }
}

class Uitel extends Osoba
{
   private String specializace;
   public Uitel(String jm, String spec)
   {
     super(jm);
     specializace = spec;
   }
   public String toString(){
    return "Uitel " + jmno + ", " + specializace;   }
}

class Pomoc
{
  // Vytiskne kolekci osob
  public static void tisk1(Collection<? extends Osoba> c)
  {
    for(Object x: c) 
      System.out.println(x);
  }
  // Vytiskne kolekci student a nadtd, 
  // ale nikoli kolekci uitel
  public static void tisk2(Collection<? super Uitel> c)
  {
    for(Object x: c) 
      System.out.println(x);
  }
}

public class Zolik2
{
  public static void main(String[] arg)
  {
    ArrayList<Osoba> alo = new ArrayList<Osoba>();
    ArrayList<Student> als = new ArrayList<Student>();
    ArrayList<Uitel> alu = new ArrayList<Uitel>();
    alo.add(new Osoba("Jan Novk"));
    alo.add(new Student("Karel Vopika", 3));
    als.add(new Student("Ji Voprlek", 3));
    als.add(new Student("Ale Koudele", 3));
    alu.add(new Uitel("Martin Hrza", "programovn"));
    alu.add(new Uitel("Ivo Kulk", "etina"));
    System.out.println("Seznam osob");
    Pomoc.tisk1(alo);
    System.out.println("Seznam student");
    Pomoc.tisk1(als);
    System.out.println("Seznam uitel");
    Pomoc.tisk1(alu);
    // Pomoc.tisk2(als);  // Chyba (Student nen nadtdou tdy Uitel)
    Pomoc.tisk2(alo);
  }
}



