// Soubor For.java
// Pklady pouit pkazu foreach
// (Novho tvaru pkazu for pro pole a kolekce)
import java.util.ArrayList;

public class For
{
   // Dvourozmrn pole
   static private int[][] pole = {{1,3,5}, {2,4,6},{9,8,7}};
   
   // Tisk pole   
   public static void tisk(int[] a)
   {
      for(int i: a)
         System.out.println(i);
   }

   // Tisk kolekce (parametrizovan metody viz dle)
   public static <T> void tisk(java.util.Collection<T> a)
   {
      for(T x: a)
         System.out.println(x);
   }

   // Tisk dvourozmrnho pole
   public static void tisk2D(int[][] toPole)
   {
     for(int[] dek: toPole)
     {
       for(int prvek: dek)
         System.out.print(prvek+" ");
       System.out.println();
     }  
  }

   public static void main(String[] s)
   {
     int [] x = {8,7,6,5,4,3};
     tisk(x);
     tisk2D(pole);
     
     // Pouijeme parametrizovan typy, viz dle
     ArrayList<Integer> ali = new ArrayList<Integer>();
     for(int i = 0; i < 5; i++)  
        ali.add(new Integer(i));  
        // Mohli bychom napsat jen 
        // ali.add(i);
        // (balen, viz dle)
     tisk(ali);
   }
}