// Soubor Kovar.java
// Kovariantn nvratov typy
// Metoda clone() vrac Osoba, nikoli Objekt

class Osoba implements Cloneable
{
  private String jmno;

  public Osoba(String jm){jmno = jm;}

  public Osoba clone() throws CloneNotSupportedException
  { 
    Osoba kopie = (Osoba)super.clone();
    kopie.jmno = new String(this.jmno);
    return kopie; 
  }
  public String toString()
  {
    return "Osoba: "+jmno;
  }
}

public class Kovar
{
  public static void main(String[] s) throws CloneNotSupportedException
  {
    Osoba os = new Osoba("Jan Kukal");
    Osoba ob = os.clone();
    System.out.println(ob);
  }
}