// Soubor Param3.java
// Parametrizovan datov typy potet
// Parametrizovan metoda v neparametrizovan td

import javax.swing.*;

class Pomocn
{
   public static <T> T sted(T[] x) 
   throws IllegalArgumentException
   {
      if(x == null || x.length == 0) 
         throw new IllegalArgumentException();
      return x[x.length / 2];
   }

   // Najde nejmen prvek pole
   public static <T extends Comparable> T max(T[] x)
   throws IllegalArgumentException
   {
     if(x == null || x.length == 0) 
         throw new IllegalArgumentException();
     T vsledek = x[0];
     for(T t: x)
        if(t.compareTo(vsledek) > 0) vsledek = t;
     return vsledek;
   }

   // a dal metody...
}



public class Param3
{
  public static void main(String [] s)
  {
    JButton[] pb = {new JButton("Makej"), new JButton("Stop"), new JButton("lus")};
    System.out.println(Pomocn.<JButton>sted(pb).getText());
    //JButton b = Pomocn.max(pb);  // Chyba, patn typ
    Integer[] n = {1,-1, 5, -5};
    Integer x = Pomocn.max(n);
    System.out.println(x);
  }
}