// Soubor PrintfTest.java
// Testy metody printf

import java.io.*;

public class PrintfTest
{
  public static void main(String[] arg) throws UnsupportedEncodingException
  {

    OutputStreamWriter osw = new OutputStreamWriter(System.out, "Cp852");
    PrintWriter Out = new PrintWriter(osw);

    System.out.printf("je to %6.3f", Math.PI);
    System.out.printf("%n----------%n");
    String jmno = "Ludolfovo slo";
    double hodnota = Math.PI;
    System.out.printf("%s m hodnotu %6.3f (zaokrouhleno)",
                  jmno, hodnota);

    System.out.printf("%n----------%n");
    Out.printf("%S m hodnotu %6.3E (zaokrouhleno)",
               jmno, hodnota);
    Out.flush();
    System.out.printf("%n----------%n");
    long x = 1234567890123L;
    Out.printf("%d %n", x);
    Out.flush();

    double y = 16.0 + 1.0/16;
    System.out.printf("%n----------%n");
    Out.printf("%E %n", y);
    Out.flush();
    System.out.printf("%n----------%n");
    Out.printf("%1$s  m hodnotu %2$6.3f (zaokrouhleno)",
                  jmno, hodnota);
    Out.flush();
    x = 17;
    System.out.printf("%n%1$d %1$#x %1$#o ", x);
    System.out.printf("%n%d %<#x %<#o", x);
    Out.printf("%n%c", '');
    Out.printf("%n%B", true);
    Out.flush();
  }
}