// Soubor Zachyt.java
// Zchyt olku

// Tda Pr parametrizovan pro jednoduchost jednm parametrem
class Pr <T>
{
   public Pr() { prvn = null; druh = null; }
   public Pr(T prvn, T druh)
   { 
      this.prvn = prvn; 
      this.druh = druh; 
   }

   public T getPrvn() { return prvn; }
   public T getDruh() { return druh; }
   public void setPrvn(T prvn) { this.prvn = prvn; }
   public void setDruh(T druh) { this.druh = druh; }
   
   public String toString() 
   {
     return prvn.toString() + " " + druh.toString();
   }

   private T prvn;
   private T druh;
}


// Tda obsahujc metodu pro prohozen sloek pru
class Pomoc
{
  // Pomocn metoda
  private static <T> void proho(Pr<T> p) 
  {
     T pom = p.getPrvn();
     p.setPrvn(p.getDruh());
     p.setDruh(pom);
  }

  // Vlastn prohozen vol pomocnou
  // metodu vyuvajc zachycen olku
  public static void swap(Pr<?> p)
  {
   proho(p);
  }
}

// Vytvo pr a prohod jeho sloky
public class Zachyt
{
  public static void main(String[] s)
  {
    Pr<String> ps = new Pr<String>("ahoj", "lidi");
    System.out.println(ps);
    Pomoc.swap(ps);
    System.out.println(ps);
  }
}